#ifndef TAS_FRONTIER_H
#define TAS_FRONTIER_H

#include "TASTiles.h"
#include "rbtrees.h"


class TASFrontierLocation : public std::vector<TASTileType*>
{
};

class TASFrontierMapEntry
{
public:
  TASFrontierMapEntry() { pTreeNode = NULL; };
  TASFrontierMapEntry(RBTreeNode* p, TASFrontierLocation& l) { pTreeNode = p; list = l; };

  bool IsValid() { return (pTreeNode != NULL) && (list.size() > 0); };

  TASFrontierLocation list;
  RBTreeNode* pTreeNode;
};

class TASFrontierMap : public std::map<TASCoords, TASFrontierMapEntry>
{

};

class TASFrontierFiller
{
public:
  TASFrontierFiller() { pTT= NULL; bValid = false; };
  TASFrontierFiller(TASTileType* p, TASCoords& c) : coords(c) { pTT = p; bValid = true; };

  bool IsValid() { return bValid; };

  bool          bValid;
  TASTileType*  pTT;
  TASCoords     coords;
};

class TASFrontier
{
public:
  bool AddLocation(TASCoords& c, TASFrontierLocation& tfl);
  bool RemoveLocation(TASCoords& c);
  size_t NumLocs() { return map.size(); };

  void PrintTree(bool bPrintNodeAddrs = false) { tree.printPaths(bPrintNodeAddrs); }; //MJP: for testing

  TASFrontierLocation* GetTilesForLocation(TASCoords& coords); 
  TASFrontierFiller GetRandomLocationAndTile();

private:
  TASFrontierLocation emptyLoc;
  TASFrontierMap map;
  RBTree  tree;
};

#endif //  TAS_FRONTIER_H